`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/28 23:16:44
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(
    input clk,
    input rst,
    output [3:0]ssd,
    output [7:0]seg,
    output high,
    output audio_mclk,
    output audio_lrck,
    output audio_sck,
    output audio_sdin,
    inout PS2_CLK,
    inout PS2_DATA
    );
    wire [511:0]key_down;
    wire [8:0]last_change;
    wire key_valid;
    wire cap;
    wire [1:0]ssd_ctl_en;
    wire [2:0]digit0;
    wire [21:0]note_div;
    wire [15:0]audio_in_left, audio_in_right;
    wire [2:0]ssd_in;

    KeyboardDecoder U0(
        .key_down(key_down),
        .last_change(last_change),
        .key_valid(key_valid),
        .PS2_DATA(PS2_DATA),
        .PS2_CLK(PS2_CLK),
        .rst(~rst),
        .clk(clk)
    );

    fsm U1(
        .last_change(last_change),
        .key_valid(key_valid),
        .clk(clk),
        .rst_n(rst),
        .cap(cap)
    );

    freq_div U5(
        .clk(clk),
        .rst_n(rst),
        .clk_ctl(ssd_ctl_en)
    );

    buzzer_ctl U_buzzer(
        .clk(clk),
        .rst_n(rst),
        .note_div(note_div),
        .audio_left(audio_in_left),
        .audio_right(audio_in_right)
    );

    speaker_ctl U_speaker(
        .clk(clk),
        .rst_n(rst),
        .audio_left(audio_in_left),
        .audio_right(audio_in_right),
        .audio_mclk(audio_mclk),
        .audio_lrck(audio_lrck),
        .audio_sck(audio_sck),
        .audio_sdin(audio_sdin)
    );

    note_sel U6(
        .key_down(key_down),
        .shift(key_down[89] | key_down[18]),
        .cap(cap),
        .high(high),
        .note_div(note_div),
        .digit0(digit0)
    );

    scan_ctl U7(
        .ssd_ctl_en(ssd_ctl_en),
        .in3(3'd0),
        .in2(3'd0),
        .in1(3'd0),
        .in0(digit0),
        .ssd_ctl(ssd),
        .ssd_in(ssd_in)
    );

    display U8(
        .in(ssd_in),
        .segs(seg)
    );
endmodule
